import MuseScore 3.0
import QtQuick 2.0

MuseScore {

    version: "1.0";
    //description: "This demo plugin adds new chords\n\n" +
    //            "Comments, feedbacks, report bugs, ask for new features, contribute:\n" +
    //            "https://github.com/rousselmanu/msc_plugins/";
    //menuPath: "Plugins.Chords." + qsTr("Add Chord Demo")
       
    
    function correctCase(s){
        var h = s.substr(0,1);
		s = h.toUpperCase() + s.substr(1);
	    return s;
    }

    
    // create and return a new Note element with given pitch, tpc
	function createNote(pitch, tpc){
		console.log("pitch = ", pitch, "tpc = ", tpc)
        var note = newElement(Element.NOTE);
        note.pitch = pitch;
		note.tpc = tpc;
        note.tpc1 = tpc;
        note.tpc2 = tpc;
        return note;
    }
    
    function setCursorToTime(cursor, time){
        cursor.rewind(0);
        while (cursor.segment) { 
            var current_time = cursor.tick;
            if(current_time>=time){
                return true;
            }
            cursor.next();
        }
        cursor.rewind(0);
        return false;
    }
    //adds chord at current position. chords is an array with pitch of notes.
	function addChord(cursor, chords, duration){ 
		for (var c = 0; c < chords.length; c++){
			console.log("chords = ", chords[c]);
		}
		if(chords.length==0) return -1;
		var cur_time=cursor.tick;
		cursor.setDuration(duration, 1920);
		cursor.addNote(chords[0]); //add 1st note
		
		var next_time=cursor.tick;
		setCursorToTime(cursor, cur_time); //rewind to this note
		var note = cursor.element.notes[0];
		note.tpc = chords[4];
		
		var chord = cursor.element; //get the chord created when 1st note was inserted
				
		for(var i=1; i<4; i++){
			var note = createNote(chords[i], chords[i+4]);
			console.log("note.pitch = ", note.pitch, "note.tpc = ", note.tpc);
			note.tpc = chords[i+4];
			chord.add(note); //add notes to the chord
			chord.notes[i].tpc = chords[i+4];
		}
		
		setCursorToTime(cursor, next_time);
		return 0;
	}
function collectchordnames(segment, chordnames,count){
    while (segment) {
        var aCount = 0;
        var annotation = segment.annotations[aCount];

        while (annotation) {
            if (annotation.type == Element.HARMONY) {
                var harmony =  annotation;
                var str = harmony.text;
                if (str != "")
                    str = correctCase(str);
                var r = str.indexOf("Maj");
                if(str.substr(str.length-3,3)== "Maj"){
                    str = str.substr(0,str.length-3)
                    console.log('Maj string = ' + str);
                }
                chordnames[count][0] = str;
                chordnames[count][1] = segment.tick;
                
                // avoid spurious empty harmonies
                if (chordnames[count][0] != ""){
                    count++;
                }					    
            }
            annotation = segment.annotations[++aCount];
        }
        segment = segment.next;
    }
    return count;
}

    onRun: {
        if (typeof curScore === 'undefined') {
            Qt.quit();
        }

        var cursor = curScore.newCursor(),
                startStaff,
                endStaff,
                endTick,
                fullScore = false;
                
        cursor.rewind(1);
        

        if (!cursor.segment) { // no selection
            fullScore = true;
            startStaff = 0; // start with 1st staff
            endStaff = curScore.nstaves - 1; // and end with last
        } else {
            startStaff = cursor.staffIdx;
            cursor.rewind(2);
            if (cursor.tick === 0) {
                // this happens when the selection includes
                // the last measure of the score.
                // rewind(2) goes behind the last segment (where
                // there's none) and sets tick=0
                endTick = curScore.lastSegment.tick + 1;
            } else {
                endTick = cursor.tick;
            }
            endStaff = cursor.staffIdx;
        }
        //console.log(startStaff + " - " + endStaff + " - " + endTick);
        //console.log('curScore.nstaves: ' + curScore.nstaves);
        //console.log('cursor.tick: ' + cursor.tick);
        //console.log('curScore.lastSegment.tick: ' + curScore.lastSegment.tick);

        cursor.rewind(1); // beginning of selection
        if (fullScore) { // no selection
            cursor.rewind(0); // beginning of score
        }
        cursor.voice = 0;
        
		//console.log('cursor.staffIdx: ' + cursor.staffIdx);
        //console.log('curScore.keysig : ' + curScore.keysig);
        //console.log('cursor.keySignature: ' + cursor.keySignature);
		
        //cursor.track = 0;

var tpc2note = [
[-1,"fbb"],
[0,"cbb"],
[1,"gbb"],
[2,"dbb"],
[3,"abb"],
[4,"ebb"],
[5,"bbb"],
[6,"fb"],
[7,"cb"],
[8,"gb"],
[9,"db"],
[10,"ab"],
[11,"eb"],
[12,"bb"],
[13,"f"],
[14,"c"],
[15,"g"],
[16,"d"],
[17,"a"],
[18,"e"],
[19,"b"],
[20,"f#"],
[21,"c#"],
[22,"g#"],
[23,"d#"],
[24,"a#"],
[25,"e#"],
[26,"b#"],
[27,"f##"],
[28,"c##"],
[29,"g##"],
[30,"d##"],
[31,"a##"],
[32,"e##"],
[33,"b##"],
];
// collect the existing chord symbols and their segment.tick
		var chordnames = new Array(1024); 
		// chordnames
		// O: chordname
		// 1: tick
		// 2: head
		// 3: tail
		for(var i=0; i<1024; i++) chordnames[i]=new Array();
		var count = 0;
		for (var track = 0; track < /*curScore.ntracks*/ 1; ++track) {
			var segment = curScore.firstSegment();
            count = collectchordnames(segment, chordnames,count);
            
		}
        // 1440 voor 3/4
		// 1920 voor 4/4
		var onemeasure = 1920;
		//add a whole note of time to the last measure
		chordnames[count][1] = chordnames[count-1][1] + onemeasure;
        setCursorToTime(cursor, chordnames[0][1]);
		cursor.staffIdx = 1;
        var cc = 0;
        while (cursor.segment) {
            if (cursor.element && cursor.element.type === Element.CHORD) {
                if (cursor.tick === chordnames[cc][1]) {
                    //console.log('cursor.tick = ' + cursor.tick)
                    //console.log('chordnames[cc][1] = ' + chordnames[cc][1])
                    var s = ""
                    // Now handle the note names on the main chord...
                    var notes = cursor.element.notes;
                    var text = "[\"" + chordnames[cc++][0] + "\",[";
                    for (var i = 0; i < notes.length; i++) {
                        
                        text += notes[i].pitch + ","
                    }
                    for (var i = 0; i < notes.length-1 ; i++) {
                        text += notes[i].tpc + ","
                        s += tpc2note[notes[i].tpc + 1][1] + ",";
                    }
                    text += notes[i].tpc;
                    s += tpc2note[notes[i].tpc + 1][1];
                    console.log(text + "],1,1],   //" + s);
                }
            }    // end if CHORD
        cursor.next();
		}
		Qt.quit();
    } // end onRun
}
